<template>
  <div id="index">
    <admin-frame @search="search" :limit="limit" :total="total" topType="2" @back="back" @add="toAdd" :useNav="false">
      <template v-slot:info>
        <list-1 :list="list" @toView="toView"></list-1>
      </template>
    </admin-frame>
    <van-dialog class="dialog" v-model="dialog.show" :title="dialog.title" :show-confirm-button="false" show-cancel-button cancel-button-text="返回">
      <info-1 :info="info" v-if="dialog.type == '1'"></info-1>
      <search-1 :form="searhForm" v-else-if="dialog.type == '2'" @reseat="reseat" @onSubmit="onSubmit"></search-1>
    </van-dialog>
  </div>
</template>

<script>
import list1 from '@/layout/learning/technology/list-1.vue';
import info1 from '@/layout/learning/technology/info-1.vue';
import search1 from '@/layout/learning/technology/search-1.vue';
import adminFrame from '@common/src/components/mobile-frame/mobile-main.vue';
import { mapState, createNamespacedHelpers } from 'vuex';
const { mapActions } = createNamespacedHelpers('technicalservice');
export default {
  name: 'index',
  props: {},
  components: {
    adminFrame,
    list1,
    info1,
    search1,
  },
  data: function () {
    return {
      list: [],
      total: 0,
      limit: 5,
      // 查询
      searhForm: {},
      // 弹框
      dialog: { show: false, title: '详细信息', type: '1' },
      // 详细信息
      info: {},
    };
  },
  async created() {
    await this.search();
  },
  methods: {
    ...mapActions(['query', 'fetch']),
    async search({ skip = 0, limit = this.limit, ...info } = {}) {
      const res = await this.query({ skip, limit, ...info });
      if (this.$checkRes(res)) {
        this.$set(this, `list`, res.rows);
        this.$set(this, `total`, res.total);
      }
    },
    // 查看信息
    async toView(data) {
      this.$set(this, `info`, data);
      this.dialog = { show: true, title: '详细信息', type: '1' };
    },
    // 添加查询条件
    toAdd() {
      this.dialog = { show: true, title: '查询条件', type: '2' };
    },
    // 重置条件
    reseat() {
      this.searhForm = {};
      this.dialog = { show: false, title: '查询条件', type: '2' };
      this.search();
    },
    // 提交查询
    onSubmit({ data }) {
      this.search(data);
      this.dialog = { show: false, title: '查询条件', type: '2' };
    },
    // 返回
    back() {
      this.$router.push({ path: '/learning/index' });
    },
  },
  computed: {
    ...mapState(['user']),
  },
  metaInfo() {
    return { title: this.$route.meta.title };
  },
  watch: {
    test: {
      deep: true,
      immediate: true,
      handler(val) {},
    },
  },
};
</script>

<style lang="less" scoped>
.dialog {
  /deep/.van-dialog__content {
    max-height: 350px;
    overflow-y: auto;
  }
}
</style>
